unit uTstCDS;
{ D5 ++
 Simple TClarionDataset DEMO with MEMO

 5.5.07
 Changes to compile under lazarus+fpc
}

{$IFDEF FPC} // freepascal compiler support
{$mode objfpc}{$H+}
{$ENDIF}

interface

uses
  Classes, SysUtils, {$IFDEF FPC}LResources,{$ENDIF} Forms, Controls, StdCtrls, Graphics, Dialogs, DbCtrls,
  Buttons, db, dbGRids, ExtCtrls, CDS, Grids;

type

  { TForm1 }

  TForm1 = class(TForm)
    Datasource1: TDatasource;
    DBGrid1: TDBGrid;
    OpenDialog1: TOpenDialog;
    btnOpen: TButton;
    DBNavigator1: TDBNavigator;
    chkUseMemo: TCheckBox;
    DBMemo1: TDBMemo;
    lblCount: TLabel;
    procedure btnOpenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure chkUseMemoClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    tblCLA: TClarionDataset;
  end;

var
  Form1: TForm1;

implementation

{$IFNDEF FPC}
 {$R *.dfm}
{$ENDIF}

procedure TForm1.btnOpenClick(Sender: TObject);
var i: integer;
    S: String;
begin
  if OpenDialog1.Execute then
  begin
     if tblCLA.Active then tblCLA.Close;
     DBMemo1.DataSource:= nil;
     DBMemo1.DataField:='';
     tblCLA.TableName := OpenDialog1.FileName;
     tblCLA.Open;
     if chkUseMemo.Checked then
       for i := 0 to tblCLA.FieldDefs.Count-1 do
        with tblCLA.FieldDefs.Items[i] do
         if DataType=ftMEMO then
         begin
           DBMemo1.DataField:=Name;
           DBMemo1.DataSource:= DataSource1 ;
         end;
     // fixing problem with DBGrid Column widths
     for i := 0 to tblCLA.Fields.Count-1 do
       with DBGrid1.Columns[i] do Width := Width-1;
     lblCount.Caption := IntToStr(tblCLA.RecordCount);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  tblCLA:=TClarionDataSet.Create(nil);
  tblCLA.OemConvert := True;
  tblCLA.BlobToCache:= chkUseMemo.Checked;
  DataSource1.DataSet:=tblCLA;
  DBMemo1.DataSource:= DataSource1 ;
  DBMemo1.DataField:='';
  OpenDialog1.FileName:='TEST.DAT';
 // tblCLA.TableName := 'TEST.DAT';
 // -misc-*-*-*-*-*-12-*-*-*-*-*-iso10646-*
 // -misc-*-medium-*-*-*-14-*-*-*-*-*-iso10646-*
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  tblCLA.Free;
end;

procedure TForm1.chkUseMemoClick(Sender: TObject);
begin
  if tblCLA.Active then tblCLA.Close;
  tblCLA.BlobToCache:= chkUseMemo.Checked;
  if chkUseMemo.Checked then
  begin
     DBMemo1.DataField:='';
     DBMemo1.DataSource:= DataSource1 ;
  end else
  begin
    DBMemo1.DataSource:= nil;
    DBMemo1.DataField:='';
  end;
end;
{$IFDEF FPC}
initialization
  {$I uTstCDS.lrs}
{$ENDIF}

end.
